Index: code/trunk/src/network/Host.cc
===================================================================
--- code/trunk/src/network/Host.cc	(revision 3073)
+++ code/trunk/src/network/Host.cc	(revision 3074)
@@ -108,4 +108,5 @@
     for (ObjectList<ChatListener>::iterator it = ObjectList<ChatListener>::begin(); it != ObjectList<ChatListener>::end(); ++it)
       it->incomingChat(message, 0);
+    return true;
   }
   else
Index: code/trunk/src/orxonox/objects/pickup/PickupCollection.cc
===================================================================
--- code/trunk/src/orxonox/objects/pickup/PickupCollection.cc	(revision 3073)
+++ code/trunk/src/orxonox/objects/pickup/PickupCollection.cc	(revision 3074)
@@ -90,5 +90,5 @@
     bool PickupCollection::checkSlot(BaseItem* item)
     {
-        return (this->items_.count(item->getPickupIdentifier()) < item->getMaxCarryAmount());
+        return ((int)this->items_.count(item->getPickupIdentifier()) < item->getMaxCarryAmount());
     }
     /**
Index: code/trunk/src/orxonox/objects/pickup/PickupInventory.cc
===================================================================
--- code/trunk/src/orxonox/objects/pickup/PickupInventory.cc	(revision 3073)
+++ code/trunk/src/orxonox/objects/pickup/PickupInventory.cc	(revision 3074)
@@ -250,5 +250,5 @@
     {
         Pawn* pawn;
-        if(pawn = HumanController::getLocalControllerEntityAsPawn())
+        if((pawn = HumanController::getLocalControllerEntityAsPawn()))
         {
             std::deque<EquipmentItem*> items = pawn->getPickups().getEquipmentItems();
@@ -274,5 +274,5 @@
     {
         Pawn* pawn;
-        if(pawn = HumanController::getLocalControllerEntityAsPawn())
+        if((pawn = HumanController::getLocalControllerEntityAsPawn()))
         {
             std::deque<UsableItem*> items = pawn->getPickups().getUsableItems();
Index: code/trunk/src/orxonox/objects/pickup/items/HealthImmediate.cc
===================================================================
--- code/trunk/src/orxonox/objects/pickup/items/HealthImmediate.cc	(revision 3073)
+++ code/trunk/src/orxonox/objects/pickup/items/HealthImmediate.cc	(revision 3074)
Index: code/trunk/src/orxonox/objects/pickup/items/HealthImmediate.h
===================================================================
--- code/trunk/src/orxonox/objects/pickup/items/HealthImmediate.h	(revision 3073)
+++ code/trunk/src/orxonox/objects/pickup/items/HealthImmediate.h	(revision 3074)
Index: code/trunk/src/orxonox/objects/pickup/items/Jump.cc
===================================================================
--- code/trunk/src/orxonox/objects/pickup/items/Jump.cc	(revision 3073)
+++ code/trunk/src/orxonox/objects/pickup/items/Jump.cc	(revision 3074)
@@ -33,5 +33,5 @@
 
 #include "Jump.h"
-#include "DroppedItem.h"
+#include "objects/pickup/DroppedItem.h"
 
 #include "objects/worldentities/pawns/Pawn.h"
Index: code/trunk/src/orxonox/objects/pickup/items/Jump.h
===================================================================
--- code/trunk/src/orxonox/objects/pickup/items/Jump.h	(revision 3073)
+++ code/trunk/src/orxonox/objects/pickup/items/Jump.h	(revision 3074)
@@ -39,5 +39,5 @@
 #include "OrxonoxPrereqs.h"
 
-#include "UsableItem.h"
+#include "objects/pickup/UsableItem.h"
 #include "util/Math.h"
 
Index: code/trunk/src/orxonox/objects/weaponsystem/Munition.cc
===================================================================
--- code/trunk/src/orxonox/objects/weaponsystem/Munition.cc	(revision 3073)
+++ code/trunk/src/orxonox/objects/weaponsystem/Munition.cc	(revision 3074)
@@ -356,5 +356,5 @@
             return false;
 
-        if (amount <= needed_magazines)
+        if (amount <= (unsigned int)needed_magazines)
         {
             // We need more magazines than we get, so just add them
Index: code/trunk/src/orxonox/objects/weaponsystem/WeaponSystem.cc
===================================================================
--- code/trunk/src/orxonox/objects/weaponsystem/WeaponSystem.cc	(revision 3073)
+++ code/trunk/src/orxonox/objects/weaponsystem/WeaponSystem.cc	(revision 3074)
@@ -214,5 +214,5 @@
         unsigned int i = 0;
         Weapon* weapon = 0;
-        while (weapon = wPack->getWeapon(i++))
+        while ((weapon = wPack->getWeapon(i++)))
             weapon->getWeaponSlot()->removeWeapon();
 