Index: code/trunk/src/orxonox/objects/pickup/DroppedItem.cc
===================================================================
--- code/trunk/src/orxonox/objects/pickup/DroppedItem.cc	(revision 3078)
+++ code/trunk/src/orxonox/objects/pickup/DroppedItem.cc	(revision 3079)
@@ -1,2 +1,30 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Daniel 'Huty' Haggenmueller
+ *   Co-authors:
+ *      ...
+ *
+ */
+
 #include "DroppedItem.h"
 
@@ -7,5 +35,4 @@
 
 #include "core/CoreIncludes.h"
-#include "core/Core.h"
 
 namespace orxonox
@@ -68,5 +95,5 @@
         Model* model = new Model(item);
         Billboard* billboard = new Billboard(item);
-        
+
         model->setMeshSource("sphere.mesh");
         model->setScale(3.0f);
Index: code/trunk/src/orxonox/objects/pickup/DroppedItem.h
===================================================================
--- code/trunk/src/orxonox/objects/pickup/DroppedItem.h	(revision 3078)
+++ code/trunk/src/orxonox/objects/pickup/DroppedItem.h	(revision 3079)
@@ -43,7 +43,4 @@
 namespace orxonox
 {
-    class BaseItem;
-    class Pawn;
-
     class _OrxonoxExport DroppedItem : public StaticEntity, public Tickable
     {
@@ -66,5 +63,5 @@
             { this->triggerDistance_ = distance; }
 
-        inline BaseItem* getItem() const 
+        inline BaseItem* getItem() const
             { return this->item_; }
         inline void setItem(BaseItem* item)
Index: code/trunk/src/orxonox/objects/pickup/ModifierPickup.cc
===================================================================
--- code/trunk/src/orxonox/objects/pickup/ModifierPickup.cc	(revision 3078)
+++ code/trunk/src/orxonox/objects/pickup/ModifierPickup.cc	(revision 3079)
@@ -37,9 +37,6 @@
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
-#include "core/Core.h"
 
 #include "objects/worldentities/pawns/Pawn.h"
-
-#include "util/Debug.h"
 
 namespace orxonox
@@ -110,5 +107,5 @@
                 this->timer_.setTimer(this->duration_, false, this, executor);
             }
-            
+
             return true;
         }
@@ -140,5 +137,5 @@
                 pawn->getPickups().removeMultiplicativeModifier((*it).first, (*it).second);
             }
-            
+
             if (this->timer_.getRemainingTime() > 0.0f)
                 this->timer_.stopTimer();
Index: code/trunk/src/orxonox/objects/pickup/PickupCollection.cc
===================================================================
--- code/trunk/src/orxonox/objects/pickup/PickupCollection.cc	(revision 3078)
+++ code/trunk/src/orxonox/objects/pickup/PickupCollection.cc	(revision 3079)
@@ -40,6 +40,4 @@
 
 #include "core/CoreIncludes.h"
-
-#include "objects/worldentities/pawns/Pawn.h"
 
 namespace orxonox
Index: code/trunk/src/orxonox/objects/pickup/PickupCollection.h
===================================================================
--- code/trunk/src/orxonox/objects/pickup/PickupCollection.h	(revision 3078)
+++ code/trunk/src/orxonox/objects/pickup/PickupCollection.h	(revision 3079)
@@ -41,5 +41,5 @@
 #include <string>
 
-#include "util/Math.h"  
+#include "util/Math.h"
 
 #include "ModifierType.h"
@@ -47,10 +47,4 @@
 namespace orxonox
 {
-    class BaseItem;
-    class EquipmentItem;
-    class PassiveItem;
-    class UsableItem;
-    class Pawn;
-
     /**
         @brief PickupCollection for organising items.
@@ -97,5 +91,5 @@
             @return Returns the pawn which owns the PickupCollection.
         */
-        inline Pawn* getOwner() const 
+        inline Pawn* getOwner() const
             { return this->owner_; }
         /**
Index: code/trunk/src/orxonox/objects/pickup/PickupInventory.cc
===================================================================
--- code/trunk/src/orxonox/objects/pickup/PickupInventory.cc	(revision 3078)
+++ code/trunk/src/orxonox/objects/pickup/PickupInventory.cc	(revision 3079)
@@ -33,5 +33,4 @@
 #include "UsableItem.h"
 
-#include "core/CoreIncludes.h"
 #include "core/ConsoleCommand.h"
 #include "core/input/InputManager.h"
@@ -50,6 +49,5 @@
 namespace orxonox
 {
-    orxonox::ConsoleCommand& function_PickupInventory_ToggleInventory_0 =
-        orxonox::CommandExecutor::addConsoleCommandShortcut(orxonox::createConsoleCommand(orxonox::createFunctor(&PickupInventory::toggleInventory), "toggleInventory"), true);
+    SetConsoleCommandShortcut(PickupInventory, toggleInventory);
 
     PickupInventory* PickupInventory::pickupInventory_s = NULL;
@@ -83,5 +81,5 @@
     }
 
-    
+
 
     void PickupInventory::toggleInventory()
@@ -303,5 +301,5 @@
 
     void PickupInventory::createItemWindows(CEGUI::WindowManager* winMgr, const std::string& id, int x, int y)
-    { 
+    {
         if(!winMgr) { return; }
 
Index: code/trunk/src/orxonox/objects/pickup/PickupInventory.h
===================================================================
--- code/trunk/src/orxonox/objects/pickup/PickupInventory.h	(revision 3078)
+++ code/trunk/src/orxonox/objects/pickup/PickupInventory.h	(revision 3079)
@@ -45,10 +45,8 @@
 {
 // tolua_end
-    class _OrxonoxExport BaseItem;
-
     /**
         @brief Static class for the inventory GUI window.
         @author Daniel 'Huty' Haggenmueller
-    */ 
+    */
 // tolua_begin
     class _OrxonoxExport PickupInventory
Index: code/trunk/src/orxonox/objects/pickup/PickupSpawner.cc
===================================================================
--- code/trunk/src/orxonox/objects/pickup/PickupSpawner.cc	(revision 3078)
+++ code/trunk/src/orxonox/objects/pickup/PickupSpawner.cc	(revision 3079)
@@ -42,5 +42,4 @@
 
 #include "objects/worldentities/pawns/Pawn.h"
-#include "objects/worldentities/triggers/DistanceTrigger.h"
 
 namespace orxonox
Index: code/trunk/src/orxonox/objects/pickup/PickupSpawner.h
===================================================================
--- code/trunk/src/orxonox/objects/pickup/PickupSpawner.h	(revision 3078)
+++ code/trunk/src/orxonox/objects/pickup/PickupSpawner.h	(revision 3079)
@@ -37,5 +37,4 @@
 #include "OrxonoxPrereqs.h"
 
-#include "core/BaseObject.h"
 #include "objects/Tickable.h"
 #include "objects/worldentities/StaticEntity.h"
@@ -44,6 +43,4 @@
 namespace orxonox
 {
-    class BaseItem;
-
     /**
         @brief PickupSpawner.
Index: code/trunk/src/orxonox/objects/pickup/items/HealthImmediate.cc
===================================================================
--- code/trunk/src/orxonox/objects/pickup/items/HealthImmediate.cc	(revision 3078)
+++ code/trunk/src/orxonox/objects/pickup/items/HealthImmediate.cc	(revision 3079)
@@ -38,5 +38,4 @@
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
-#include "core/Core.h"
 
 namespace orxonox
Index: code/trunk/src/orxonox/objects/pickup/items/HealthImmediate.h
===================================================================
--- code/trunk/src/orxonox/objects/pickup/items/HealthImmediate.h	(revision 3078)
+++ code/trunk/src/orxonox/objects/pickup/items/HealthImmediate.h	(revision 3079)
@@ -37,10 +37,8 @@
 #include "OrxonoxPrereqs.h"
 
-#include "../PassiveItem.h"
+#include "objects/pickup/PassiveItem.h"
 
 namespace orxonox
 {
-    class Pawn;
-
     /**
         @brief Health-item, immediatly recovers health when picked up.
Index: code/trunk/src/orxonox/objects/pickup/items/HealthUsable.cc
===================================================================
--- code/trunk/src/orxonox/objects/pickup/items/HealthUsable.cc	(revision 3078)
+++ code/trunk/src/orxonox/objects/pickup/items/HealthUsable.cc	(revision 3079)
@@ -33,5 +33,5 @@
 
 #include "HealthUsable.h"
-#include "../DroppedItem.h"
+#include "objects/pickup/DroppedItem.h"
 
 #include "objects/worldentities/pawns/Pawn.h"
@@ -39,5 +39,4 @@
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
-#include "core/Core.h"
 
 namespace orxonox
Index: code/trunk/src/orxonox/objects/pickup/items/HealthUsable.h
===================================================================
--- code/trunk/src/orxonox/objects/pickup/items/HealthUsable.h	(revision 3078)
+++ code/trunk/src/orxonox/objects/pickup/items/HealthUsable.h	(revision 3079)
@@ -37,11 +37,9 @@
 #include "OrxonoxPrereqs.h"
 
-#include "../UsableItem.h"
+#include "objects/pickup/UsableItem.h"
 #include "util/Math.h"
 
 namespace orxonox
 {
-    class Pawn;
-
     /**
         @brief Health-item, enables player recover health when used.
Index: code/trunk/src/orxonox/objects/pickup/items/Jump.cc
===================================================================
--- code/trunk/src/orxonox/objects/pickup/items/Jump.cc	(revision 3078)
+++ code/trunk/src/orxonox/objects/pickup/items/Jump.cc	(revision 3079)
@@ -39,5 +39,4 @@
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
-#include "core/Core.h"
 
 namespace orxonox
Index: code/trunk/src/orxonox/objects/pickup/items/Jump.h
===================================================================
--- code/trunk/src/orxonox/objects/pickup/items/Jump.h	(revision 3078)
+++ code/trunk/src/orxonox/objects/pickup/items/Jump.h	(revision 3079)
@@ -44,6 +44,4 @@
 namespace orxonox
 {
-    class Pawn;
-
     /**
         @brief Jump-item, enables player to "jump" into a direction.